.\" $NetBSD: pthread_barrier_init.3,v 1.8 2008/04/30 13:10:52 martin Exp $
.\"
.\" Copyright (c) 2002 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd January 30, 2003
.Dt PTHREAD_BARRIER_INIT 3
.Os
.Sh NAME
.Nm pthread_barrier_init
.Nd create a barrier
.Sh LIBRARY
.Lb libpthread
.Sh SYNOPSIS
.In pthread.h
.Ft int
.Fn pthread_barrier_init "pthread_barrier_t * restrict barrier" "const pthread_barrierattr_t * restrict attr" "unsigned int count"
.Sh DESCRIPTION
The
.Fn pthread_barrier_init
function creates a new barrier, with attributes specified with
.Fa attr
and
.Fa count .
The
.Fa count
parameter indicates the number of threads which will participate in the barrier.
If
.Fa attr
is NULL the default attributes are used.
Barriers are most commonly used in the decomposition of parallel loops.
.Sh RETURN VALUES
If successful,
.Fn pthread_barrier_init
will return zero and put the new barrier id into
.Fa barrier ,
otherwise an error number will be returned to indicate the error.
.Sh ERRORS
.Fn pthread_barrier_init
shall fail if:
.Bl -tag -width Er
.It Bq Er EAGAIN
The system lacks the resources to initialize another barrier.
.It Bq Er EINVAL
The value specified by
.Fa count
is zero.
.It Bq Er ENOMEM
Insufficient memory exists to initialize the barrier.
.El
.Pp
.Fn pthread_barrier_init
may fail if:
.Bl -tag -width Er
.It Bq Er EBUSY
The barrier structure has been initialized already.
.It Bq Er EINVAL
The value specified by
.Fa attr
is invalid.
.El
.Sh SEE ALSO
.Xr pthread_barrier_destroy 3 ,
.Xr pthread_barrier_wait 3 ,
.Xr pthread_barrierattr_destroy 3 ,
.Xr pthread_barrierattr_init 3
.Sh STANDARDS
.Fn pthread_barrier_init
conforms to
.St -p1003.1-2001 .
